/*
 * Ce sketch est destiné à être utilisé conjointement avec le
 * script python "variateur.py" fourni dans la même archive.
 * L'ensemble de ces deux programmes permet de faire varier
 * la luminosité d'une LED à l'aide d'un curseur virtuel manipulé
 * par la souris.
 * 
 * © naute 2019 CC-BY-SA-NC
 */


const int led = 9; //PWM
char reception;
String strReception = "";
byte consigne;  // De 0 à 255

void setup() 
{
  pinMode(led, OUTPUT);
  Serial.begin(115200);
  Serial.flush();  
}

void loop()
{
  while (Serial.available() > 0)
  {
    reception = Serial.read();
    strReception += reception;
    delay(1);
  }
  if (strReception != "")
  {
    consigne = stringToInt(strReception);
    analogWrite(led, consigne);
    strReception = "";   
  }
}


/***********************************************************
***************** PROCÉDURES & FONCTIONS *******************
***********************************************************/

unsigned long pow10(int p)
// Retourne 10 à la puissance p :
// p est dans l'intervalle [0..9].
{
  unsigned long result = 1;
  for (int i=0; i < p; i++)
  {
    result = result * 10;
  }
  return result;
}

int stringToInt(String chaine)
// Transtype une String en int : les caractères 
// constituant la chaine doivent appartenir à 
// l'ensemble ["0".."9"].
{
  int nbCar, numCar, result, exposant;
  char car;
  nbCar = chaine.length();
  numCar = 0;
  result = 0;
  while (numCar < nbCar)
  {
    car = chaine.charAt(numCar);
    exposant = nbCar - numCar - 1;   
    result += (car - 48) * pow10(exposant);
    numCar += 1;
  }
  return result;
}




